.Const

.Data?

.Data

sz100000			Byte		"0 - 100#000", 0
sz500000			Byte		"0 - 500#000", 0
sz1000000			Byte		"0 - 1#000#000", 0
sz5000000			Byte		"0 - 5#000#000", 0
sz10000000			Byte		"0 - 10#000#000", 0
sz20000000			Byte		"0 - 20#000#000", 0
sz50000000			Byte		"0 - 50#000#000", 0
sz100000000			Byte		"0 - 100#000#000", 0
sz200000000			Byte		"0 - 200#000#000", 0
sz300000000			Byte		"0 - 300#000#000", 0
sz600000000			Byte		"0 - 600#000#000", 0
sz1024000000		Byte		"0 - 1024#000#000", 0

lFilterMode			QWord		0

crCurrentDownColor	COLORREF	0
crMeterNewDownColor	COLORREF	0
crMeterOldDownColor	COLORREF	0
crCurrentUpColor	COLORREF	0
crMeterNewUpColor	COLORREF	0
crMeterOldUpColor	COLORREF	0

hIconDown			HICON		NULL
hIconUp				HICON		NULL


include ECProtos.inc ; .Code

SettingsProcedure Proc FastCall Frame hWnd:HWND, uMsg:QWord, wParam:WPARAM, lParam:LPARAM
    .If uMsg == WM_CREATE
    	Lea Rsi, szBuffer
		Invoke LoadAndSetText, hWnd, Rsi, IDS_CANCEL, IDC_SETTINGS_BTNCANCEL
		Invoke LoadAndSetText, hWnd, Rsi, IDS_OK, IDC_SETTINGS_BTNOK
		Invoke LoadAndSetText, hWnd, Rsi, IDS_METER, IDC_SETTINGS_GROUP1
		Invoke LoadAndSetText, hWnd, Rsi, IDS_TRANSFER_SPEED, IDC_SETTINGS_GROUP2
		Invoke LoadAndSetText, hWnd, Rsi, IDS_COLOR, IDC_SETTINGS_GROUP3
		Invoke LoadAndSetText, hWnd, Rsi, IDS_RANGE, IDC_SETTINGS_GROUP4
		Invoke LoadAndSetText, hWnd, Rsi, IDS_PORTS, IDC_SETTINGS_GROUP5
		Invoke LoadAndSetText, hWnd, Rsi, IDS_NF, IDC_SETTINGS_RADIO3
		Invoke LoadAndSetText, hWnd, Rsi, IDS_PROM, IDC_SETTINGS_RADIO4
		Invoke LoadAndSetText, hWnd, Rsi, IDS_WF, IDC_SETTINGS_RADIO5
		Invoke LoadAndSetText, hWnd, Rsi, IDS_DOWNLOAD, IDC_SETTINGS_STATIC1
		Invoke LoadAndSetText, hWnd, Rsi, IDS_UPLOAD, IDC_SETTINGS_STATIC2
		Invoke LoadAndSetText, hWnd, Rsi, IDS_EVERY, IDC_SETTINGS_STATIC3
		Invoke LoadAndSetText, hWnd, Rsi, IDS_SECONDS, IDC_SETTINGS_STATIC4

		Mov Eax, crMeterDownColor
		Mov crCurrentDownColor, Eax
		Mov crMeterNewDownColor, Eax
		Mov crMeterOldDownColor, Eax
		Mov Eax, crMeterUpColor
		Mov crCurrentUpColor, Eax
		Mov crMeterNewUpColor, Eax
		Mov crMeterOldUpColor, Eax
		Mov Rax, FilterMode
		Mov lFilterMode, Rax
		Invoke SetRightSeparator, Addr sz100000
		Invoke SetRightSeparator, Addr sz500000
		Invoke SetRightSeparator, Addr sz1000000
		Invoke SetRightSeparator, Addr sz5000000
		Invoke SetRightSeparator, Addr sz10000000
		Invoke SetRightSeparator, Addr sz20000000
		Invoke SetRightSeparator, Addr sz50000000
		Invoke SetRightSeparator, Addr sz100000000
		Invoke SetRightSeparator, Addr sz200000000
		Invoke SetRightSeparator, Addr sz300000000
		Invoke SetRightSeparator, Addr sz600000000
		Invoke SetRightSeparator, Addr sz1024000000
		Invoke LoadImage, App.Instance, IDI_ICON_DOWN_ON, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconDown, Rax
		Invoke LoadImage, App.Instance, IDI_ICON_UP_ON, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconUp, Rax
		.If crMeterDownColor != 00FFFF00H
			Invoke ChangeIconColor, hIconDown, 00FFFF00H, crMeterDownColor
			.If Rax
				Xchg hIconDown, Rax
				Invoke DestroyIcon, Rax
			.EndIf
			Invoke ChangeIconColor, hIconReceive, 00FFFF00H, crMeterDownColor
			.If Rax
				Xchg hIconReceive, Rax
				Invoke DestroyIcon, Rax
			.EndIf
			Invoke ChangeIconColor, hIconBoth, 00FFFF00H, crMeterDownColor
			.If Rax
				Xchg hIconBoth, Rax
				Invoke DestroyIcon, Rax
			.EndIf
		.EndIf
		.If crMeterUpColor != 0000FFFFH
			Invoke ChangeIconColor, hIconUp, 0000FFFFH, crMeterUpColor
			.If Rax
				Xchg hIconUp, Rax
				Invoke DestroyIcon, Rax
			.EndIf
			Invoke ChangeIconColor, hIconSend, 0000FFFFH, crMeterUpColor
			.If Rax
				Xchg hIconSend, Rax
				Invoke DestroyIcon, Rax
			.EndIf
			Invoke ChangeIconColor, hIconBoth, 0000FFFFH, crMeterUpColor
			.If Rax
				Xchg hIconBoth, Rax
				Invoke DestroyIcon, Rax
			.EndIf
		.EndIf
		Mov Rax, Rsi
		Mov Byte Ptr [Rax], VK_SPACE
		Inc Rax
		Invoke LoadAppString, IDS_SETTINGS, Rax, 64
		Invoke GetNoEllipsisText, Rsi
		Invoke GetNoPrefixString, Rsi
		Invoke SetText, hWnd, Rsi
		Invoke LoadAppString, IDS_REFRESH, Rsi, 64
		Invoke GetNoPrefixString, Rsi
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_GROUP6
		Invoke SetWindowText, Rax, Rsi

		.If bBits
			Invoke GetWindowItem, hWnd, IDC_SETTINGS_RADIO1
			Invoke SendMessage, Rax, BM_SETCHECK, BST_CHECKED, 0
		.EndIf
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_COMBO1
		Mov Rdi, Rax
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_COMBO2
		Mov Rsi, Rax
		Invoke SendMessage, Rdi, CB_RESETCONTENT, 0, 0
		Invoke SendMessage, Rsi, CB_RESETCONTENT, 0, 0
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz100000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz100000
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz500000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz500000
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz1000000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz1000000
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz5000000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz5000000
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz10000000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz10000000
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz20000000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz20000000
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz50000000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz50000000
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz100000000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz100000000
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz200000000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz200000000
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz300000000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz300000000
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz600000000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz600000000
		Invoke SendMessage, Rdi, CB_ADDSTRING, 0, Addr sz1024000000
		Invoke SendMessage, Rsi, CB_ADDSTRING, 0, Addr sz1024000000

		Invoke SendMessage, Rdi, CB_SETCURSEL, lMeterDownMaxValueEnum, 0
		Invoke SendMessage, Rsi, CB_SETCURSEL, lMeterUpMaxValueEnum, 0
		Invoke String, lAutoRefreshPorts, Addr szBuffer, ecDecimal
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_EDIT1
		Invoke SetWindowText, Rax, Addr szBuffer
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_BTNCANCEL
		Invoke SetDefault, Rax, TRUE
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_BTNOK
		Invoke SetEnabled, Rax, FALSE

		.If lFilterMode == 0
			Mov Rax, IDC_SETTINGS_RADIO3
		.ElseIf lFilterMode == 1
			Mov Rax, IDC_SETTINGS_RADIO4
		.ElseIf lFilterMode == 2
			Mov Rax, IDC_SETTINGS_RADIO5
		.EndIf
		Invoke GetWindowItem, hWnd, Rax
		Invoke SendMessage, Rax, BM_SETCHECK, BST_CHECKED, 0

		.If KBValue == 1024
			Mov Rax, IDC_SETTINGS_RADIO6
		.Else
			Mov Rax, IDC_SETTINGS_RADIO7
		.EndIf
		Invoke GetWindowItem, hWnd, Rax
		Invoke SendMessage, Rax, BM_SETCHECK, BST_CHECKED, 0

    .ElseIf uMsg == WM_COMMAND
        Mov Rdi, wParam
        And Rdi, 00000000FFFFFFFFH
        Mov Rsi, Rdi
        Shr Edi, 16
        And Esi, 0000FFFFH
        Invoke OnSettingsCommand, hWnd, Rsi, Rdi, lParam
@@:     Ret
    .ElseIf uMsg == WM_CLOSE
        Invoke IsModal, hWnd
        .If Rax
            Invoke EndModal, hWnd, IDCANCEL
            Mov Rax, TRUE   ;Return TRUE
            Jmp @B
        .EndIf
    .ElseIf uMsg == WM_DESTROY
		Invoke DestroyIcon, hIconDown
		Invoke DestroyIcon, hIconUp
    .EndIf
    Xor Rax, Rax    ;Return FALSE
    Jmp @B
SettingsProcedure EndP

OnSettingsCommand Proc FastCall Private Frame Uses Rdi hWndParent:HWND, uCtlID:QWord, uCode:QWord, hWndChild:HWND
	Local chColor:CHOOSECOLOR

    Mov hWndParent, Rcx
    Mov uCtlID, Rdx
    Mov uCode, R8
    Mov hWndChild, R9

	Mov Rax, uCtlID
	.If Eax == IDC_SETTINGS_BTNCANCEL
		Mov Rax, uCode
		.If Eax == BN_CLICKED
			Invoke SendMessage, hWndParent, WM_CLOSE, 0, 0
			Return TRUE
		.EndIf
	.ElseIf Eax == IDC_SETTINGS_RADIO1 || Eax == IDC_SETTINGS_RADIO2
		Mov Rax, uCode
		.If Eax == BN_CLICKED
L2:			Invoke GetWindowItem, hWndParent, IDC_SETTINGS_BTNOK
			Mov Rdi, Rax
			Invoke EnableWindow, Rax, TRUE
			Invoke SetDefault, Rdi, TRUE
			Return TRUE
		.EndIf
	.ElseIf Eax == IDC_SETTINGS_COMBO1 || Eax == IDC_SETTINGS_COMBO2
		Mov Rax, uCode
		.If Eax == CBN_SELCHANGE
			Jmp L2
		.EndIf
	.ElseIf Eax == IDC_SETTINGS_BTNDOWN || Eax == IDC_SETTINGS_BTNUP
		Mov Rbx, Rax
		Mov Rax, uCode
		.If Eax == BN_CLICKED
			Mov chColor.lStructSize, SizeOf CHOOSECOLOR
			Move chColor.hwndOwner, hWndParent
			Mov chColor.hInstance, NULL
			Mov Eax, crMeterNewDownColor
			.If Ebx == IDC_SETTINGS_BTNUP
				Mov Eax, crMeterNewUpColor
			.EndIf
			Mov chColor.rgbResult, Eax
			Lea Rax, szBuffer
			Mov chColor.lpCustColors, Rax
			Mov chColor.Flags, CC_ANYCOLOR
			Cmp chColor.rgbResult, 0
			Jl @F
			Or chColor.Flags, CC_RGBINIT
@@:			Mov chColor.lCustData, NULL
			Mov chColor.lpfnHook, NULL
			Mov chColor.lpTemplateName, NULL
			Invoke ChooseColor, Addr chColor
			.If Rax
				Mov Eax, chColor.rgbResult
				Lea Rdi, crMeterNewDownColor
				.If Ebx == IDC_SETTINGS_BTNUP
					Lea Rdi, crMeterNewUpColor
				.EndIf
				.If (Rax != QWord Ptr [Rdi])
					Mov QWord Ptr [Rdi], Rax
					Mov Rax, hIconDown
					Mov Edx, crMeterNewDownColor
					.If Ebx == IDC_SETTINGS_BTNUP
						Mov Rax, hIconUp
						Mov Edx, crMeterNewUpColor
					.EndIf
					Mov Rdi, Rdx
					Lea Rsi, hIconDown
					Mov Rax, IDI_ICON_DOWN_WHITE
					.If Ebx == IDC_SETTINGS_BTNUP
						Lea Rsi, hIconUp
						Mov Rax, IDI_ICON_UP_WHITE
					.EndIf
					Invoke LoadImage, App.Instance, Rax, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
					Xchg QWord Ptr [Rsi], Rax
					Invoke DestroyIcon, Rax
					Invoke ChangeIconColor, QWord Ptr [Rsi], 00FFFFFFH, Rdi
					Mov Rdi, IDC_SETTINGS_IMGDOWN
					Lea Rsi, hIconDown
					.If Ebx == IDC_SETTINGS_BTNUP
						Mov Rdi, IDC_SETTINGS_IMGUP
						Lea Rsi, hIconUp
					.EndIf
					Xchg QWord Ptr [Rsi], Rax
					Invoke DestroyIcon, Rax
					Invoke GetWindowItem, hWndParent, Rdi
					Invoke InvalidateRect, Rax, NULL, TRUE
					Lea Rdi, crMeterOldDownColor
					.If Ebx == IDC_SETTINGS_BTNUP
						Lea Rdi, crMeterOldUpColor
					.EndIf
					Mov Eax, chColor.rgbResult
					Mov QWord Ptr [Rdi], Rax
					Jmp L2
				.EndIf
			.EndIf
			Return TRUE
		.EndIf
	.ElseIf Eax == IDC_SETTINGS_EDIT1
		Mov Rax, uCode
		.If Eax == EN_CHANGE
			Jmp L2
		.EndIf
	.ElseIf Eax == IDC_SETTINGS_BTNOK
		Mov Rax, uCode
		.If Eax == BN_CLICKED
			Invoke GetWindowItem, hWndParent, IDC_SETTINGS_RADIO1
			Invoke SendMessage, Rax, BM_GETCHECK, 0, 0
			.If Rax == BST_UNCHECKED
				Mov bBits, FALSE
			.Else
				Mov bBits, TRUE
			.EndIf
			Invoke wsprintfA, Addr szBuffer, Addr szFormat, bBits
			Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBits, Addr szBuffer

			Invoke GetWindowItem, hWndParent, IDC_SETTINGS_COMBO1
			Invoke SendMessage, Rax, CB_GETCURSEL, 0, 0
			Mov lMeterDownMaxValueEnum, Rax
			Invoke wsprintfA, Addr szBuffer, Addr szFormat, Rax
			Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterDownMaxValueEnum, Addr szBuffer
			Invoke CheckMeterMaxValue, lMeterDownMaxValueEnum, Addr lMeterDownMaxValue
			Invoke SetMeterMaxValue, lMeterDownIndex, lMeterDownMaxValue
			
			Invoke GetWindowItem, hWndParent, IDC_SETTINGS_COMBO2
			Invoke SendMessage, Rax, CB_GETCURSEL, 0, 0
			Mov lMeterUpMaxValueEnum, Rax
			Invoke wsprintfA, Addr szBuffer, Addr szFormat, Rax
			Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterUpMaxValueEnum, Addr szBuffer
			Invoke CheckMeterMaxValue, lMeterUpMaxValueEnum, Addr lMeterUpMaxValue
			Invoke SetMeterMaxValue, lMeterUpIndex, lMeterUpMaxValue

			Mov Rax, lFilterMode
			Mov FilterMode, Rax
			Invoke wsprintfA, Addr szBuffer, Addr szFormat, Rax
			Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFilterMode, Addr szBuffer

			Invoke GetWindowItem, hWndParent, IDC_SETTINGS_RADIO6
			Invoke SendMessage, Rax, BM_GETCHECK, 0, 0
			.If Rax == BST_CHECKED
				Mov Rax, 1024
			.Else
				Mov Rax, 1000
			.EndIf
			Mov KBValue, Rax
			Invoke StringA, Rax, Addr szBuffer, ecDecimal
			Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szKBValue, Addr szBuffer
			Invoke SetKBValues

			Mov Eax, crMeterNewDownColor
			.If Eax != crMeterDownColor
				Mov crMeterDownColor, Eax
				Invoke StringA, Rax, Addr szBuffer, ecDecimal
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterDownColor, Addr szBuffer
				Invoke SetMeterDownNewColor, crCurrentDownColor
			.EndIf
			Mov Eax, crMeterNewUpColor
			.If Eax != crMeterUpColor
				Mov crMeterUpColor, Eax
				Invoke StringA, Rax, Addr szBuffer, ecDecimal
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterUpColor, Addr szBuffer
				Invoke SetMeterUpNewColor, crCurrentUpColor
			.EndIf
			Invoke SetIcons, IconData.hIcon
			Invoke UpdateLights, TRUE, TRUE
			Invoke GetWindowItem, hWndParent, IDC_SETTINGS_EDIT1
			Invoke GetWindowText, Rax, Addr szBuffer, 2
			Invoke ValueA, Addr szBuffer
			Mov lAutoRefreshPorts, Rax
			Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szAutoRefreshPorts, Addr szBuffer
			Invoke EndModal, hWndParent, IDOK
			Return TRUE
		.EndIf
	.ElseIf Eax == IDC_SETTINGS_RADIO3
		.If uCode == BN_CLICKED
			Mov lFilterMode, 0
			Jmp L2
		.EndIf
	.ElseIf Eax == IDC_SETTINGS_RADIO4
		.If uCode == BN_CLICKED
			Mov lFilterMode, 1
			Mov lLastBytesInIndex, 0
			Mov lLastBytesOutIndex, 0
			Invoke RtlZeroMemory, Addr lpLastBytesIn, SizeOf LPLONG * 16
			Invoke RtlZeroMemory, Addr lpLastBytesOut, SizeOf LPLONG * 16
		.EndIf
		Jmp L2
	.ElseIf Eax == IDC_SETTINGS_RADIO5
		.If uCode == BN_CLICKED
			Mov lFilterMode, 2
			Mov QWord Ptr lpLastBytesIn, 0
			Mov QWord Ptr lpLastBytesOut, 0
			Finit
			Jmp L2
		.EndIf
	.ElseIf Eax == IDC_SETTINGS_RADIO6 || Eax == IDC_SETTINGS_RADIO7
		.If uCode == BN_CLICKED
			Jmp L2
		.EndIf
	.EndIf
    Xor Rax, Rax    ;Return FALSE
    Ret
OnSettingsCommand EndP

SettingsImgDown Proc FastCall Private Frame hWnd:HWND, uMsg:QWord, wParam:WPARAM, lParam:LPARAM
	Mov hWnd, Rcx
	Mov uMsg, Rdx
	Mov wParam, R8
	Mov lParam, R9

	.If uMsg == WM_PAINT
		Invoke PaintImage, hWnd, hIconDown
		Mov Rax, TRUE
		Jmp @F
	.EndIf
	Xor Rax, Rax
@@:	Ret
SettingsImgDown EndP

SettingsImgUp Proc FastCall Private Frame hWnd:HWND, uMsg:QWord, wParam:WPARAM, lParam:LPARAM
	Mov hWnd, Rcx
	Mov uMsg, Rdx
	Mov wParam, R8
	Mov lParam, R9

	.If uMsg == WM_PAINT
		Invoke PaintImage, hWnd, hIconUp
		Mov Rax, TRUE
		Jmp @F
	.EndIf
	Xor Rax, Rax
@@:	Ret
SettingsImgUp EndP

PaintImage Proc FastCall Private Frame hWnd:HWND, hIcon:HICON
	Local ps:PAINTSTRUCT

	Mov hWnd, Rcx
	Mov hIcon, Rdx

	Invoke BeginPaint, hWnd, Addr ps
	Invoke GetClientRect, hWnd, Addr ps.rcPaint
	Invoke GetSysColorBrush, COLOR_BTNFACE
	Invoke FillRect, ps.hdc, Addr ps.rcPaint, Rax
	Invoke DrawIconEx, ps.hdc, 4, 3, hIcon, 16, 16, NULL, NULL, DI_NORMAL
	Invoke EndPaint, hWnd, Addr ps
	Ret
PaintImage EndP

SetRightSeparator Proc FastCall Private Frame Uses Rsi lpszString:LPSTR
	Mov Rsi, Rcx ;lpszString
	Mov Al, sThousand
	.While Byte Ptr [Rsi] != 0
		.If Byte Ptr [Rsi] == "#"
			Mov Byte Ptr [Rsi], Al
		.EndIf
		Inc Rsi
	.EndW
	Ret
SetRightSeparator EndP
